<?php
namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class Sm00004003ItemReajusteContratoController extends SMCrud
{
    protected $dataSourceName = 'fct_itemcontrato_reajuste';

    public function __construct($crudService, $environment) {
        parent::__construct($crudService, $environment);
    }
    
    public function find(Request\Filter $request, Response $response){
        try {
            parent::find($request, $response);
            $rows = $response->getDataSets()[0]->getRows();
            foreach($rows as &$row){
                if($row["IDTIPO"] == "M"){
                    $row["VRUNITITEMCONT_GRID"] = number_format((double)$row["VRUNITITEMCONT_GRID"], 2, ",", ".");
                    $row["QTMEDIDACONTR_GRID"]  = number_format((double)$row["QTMEDIDACONTR_GRID"], 2, ",", ".");
                }
            }
            unset($row);

            $response->setDataSets(array(new DataSet("fct_itemcontrato_reajuste", $rows)));
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}

?>