
IF EXISTS(SELECT
             NAME
          FROM
             SYSOBJECTS
          WHERE
             NAME = 'ATUALIZA_DADOS_DESPDIVERSA' AND
             TYPE = 'TR')


  DROP TRIGGER ATUALIZA_DADOS_DESPDIVERSA
  GO


CREATE TRIGGER ATUALIZA_DADOS_DESPDIVERSA
ON DESPPREVFILI
FOR UPDATE, INSERT, DELETE
AS

   DECLARE @V_DTINICIAL         DATETIME;
   DECLARE @V_DTFINAL           DATETIME;
   DECLARE @V_IDFECHDIAROP    VARCHAR(1);
   DECLARE @V_NEW_CDFILIAL    VARCHAR(4);
   DECLARE @V_OLD_CDFILIAL    VARCHAR(4);
   DECLARE @V_NEW_DTPRDESPFILI  DATETIME;
   DECLARE @V_OLD_DTPRDESPFILI  DATETIME;
   DECLARE @V_ID_COMANDO      VARCHAR(1);
   DECLARE @V_IDUTPADRROP     VARCHAR(1);
   DECLARE @V_IDUTPADRROPFIL  VARCHAR(1);
   DECLARE @V_NEW_VRPRDESPFILI     FLOAT;
   DECLARE @V_NEW_VRREDESPFILI     FLOAT;
   DECLARE @V_OLD_VRPRDESPFILI     FLOAT;
   DECLARE @V_OLD_VRREDESPFILI     FLOAT;

BEGIN
   SET @V_ID_COMANDO = 'N';

   DECLARE C_CURSOR_DATA CURSOR FOR
      SELECT
        'U' IDCOMANDO,
        DELETED.CDFILIAL,
        DELETED.DTPRDESPFILI,
        INSERTED.CDFILIAL,
        INSERTED.DTPRDESPFILI,
        INSERTED.VRPRDESPFILI,
        INSERTED.VRREDESPFILI,
        DELETED.VRPRDESPFILI,
        DELETED.VRREDESPFILI
      FROM
          DELETED,
          INSERTED
      WHERE
         INSERTED.CDFILIAL  = DELETED.CDFILIAL

      UNION ALL

      SELECT
        'D' IDCOMANDO,
        DELETED.CDFILIAL,
        DELETED.DTPRDESPFILI,
        NULL, NULL, NULL, NULL,
        DELETED.VRPRDESPFILI,
        DELETED.VRREDESPFILI
      FROM
        DELETED
      WHERE
        0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
        'I' IDCOMANDO,
        NULL, NULL,
        INSERTED.CDFILIAL,
        INSERTED.DTPRDESPFILI,
        INSERTED.VRPRDESPFILI,
        INSERTED.VRREDESPFILI,
        NULL, NULL
      FROM
        INSERTED
      WHERE
        0 = (SELECT COUNT(*) FROM DELETED);

   OPEN C_CURSOR_DATA;
   FETCH NEXT FROM C_CURSOR_DATA INTO @V_ID_COMANDO,
                                      @V_OLD_CDFILIAL,
                                      @V_OLD_DTPRDESPFILI,
                                      @V_NEW_CDFILIAL,
                                      @V_NEW_DTPRDESPFILI,
                                      @V_NEW_VRPRDESPFILI,
                                      @V_NEW_VRREDESPFILI,
                                      @V_OLD_VRPRDESPFILI,
                                      @V_OLD_VRREDESPFILI;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'U' BEGIN
         SELECT @V_IDUTPADRROP = IDUTPADRROP
         FROM PARAMGERAL G;

         SELECT @V_IDFECHDIAROP   = ISNULL(MAX(IDFECHDIAROP),'N'),
                @V_IDUTPADRROPFIL = ISNULL(MAX(IDUTPADRROPFIL),'N')
         FROM  PARFILIALROP
         WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);

         IF @V_IDUTPADRROP = 'S' OR @V_IDUTPADRROPFIL = 'S' BEGIN
            SELECT @V_IDFECHDIAROP   = ISNULL(MAX(IDFECHDIAROP),'N'),
                   @V_IDUTPADRROPFIL = ISNULL(MAX(IDUTPADRROPFIL),'N')
            FROM  PARFILIALROP
            WHERE CDFILIAL = 'P';
         END;

         IF (@V_NEW_DTPRDESPFILI <> @V_OLD_DTPRDESPFILI) OR
            (@V_NEW_VRPRDESPFILI <> @V_OLD_VRPRDESPFILI) OR
            (@V_NEW_VRREDESPFILI <> @V_OLD_VRREDESPFILI) BEGIN
            SELECT @V_DTINICIAL = MAX(DTINIAPURACROP),
                   @V_DTFINAL   = MAX(DTFINAPURACROP)
            FROM APURACAOROP
            WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);

            IF (ISNULL(@V_IDFECHDIAROP,'N') <> 'S') BEGIN

               IF (@V_NEW_DTPRDESPFILI < @V_DTFINAL)  AND (@V_NEW_DTPRDESPFILI < @V_DTINICIAL) BEGIN

                  UPDATE APURACAOROP
                  SET DTINIAPURACROP  = @V_NEW_DTPRDESPFILI
                  WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);
               END;

            END
            ELSE BEGIN
               DELETE ROPFILIAL
               WHERE CDFILIAL     = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL)  AND
                     DTFILIALROP  >= @V_NEW_DTPRDESPFILI;

               IF (@V_NEW_DTPRDESPFILI < @V_DTINICIAL) BEGIN
                  UPDATE APURACAOROP
                  SET  DTINIAPURACROP  = @V_NEW_DTPRDESPFILI
                  WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);
               END;

            END;
         END;
      END;

      IF @V_ID_COMANDO = 'I' BEGIN
         SELECT @V_IDUTPADRROP = IDUTPADRROP
         FROM PARAMGERAL G;

         SELECT @V_IDFECHDIAROP   = ISNULL(MAX(IDFECHDIAROP),'N'),
                @V_IDUTPADRROPFIL = ISNULL(MAX(IDUTPADRROPFIL),'N')
         FROM  PARFILIALROP
         WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);

         IF @V_IDUTPADRROP = 'S' OR @V_IDUTPADRROPFIL = 'S' BEGIN
            SELECT @V_IDFECHDIAROP   = ISNULL(MAX(IDFECHDIAROP),'N'),
                   @V_IDUTPADRROPFIL = ISNULL(MAX(IDUTPADRROPFIL),'N')
            FROM  PARFILIALROP
            WHERE CDFILIAL = 'P';
         END;

         SELECT @V_DTINICIAL = MAX(DTINIAPURACROP),
                   @V_DTFINAL   = MAX(DTFINAPURACROP)
            FROM APURACAOROP
            WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);

            IF (ISNULL(@V_IDFECHDIAROP,'N') <> 'S') BEGIN

               IF (@V_NEW_DTPRDESPFILI < @V_DTFINAL)  AND (@V_NEW_DTPRDESPFILI < @V_DTINICIAL) BEGIN

                  UPDATE APURACAOROP
                  SET DTINIAPURACROP  = @V_NEW_DTPRDESPFILI
                  WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);
               END;

            END
            ELSE BEGIN
               DELETE ROPFILIAL
               WHERE CDFILIAL     = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL)  AND
                     DTFILIALROP  >= @V_NEW_DTPRDESPFILI;

               IF (@V_NEW_DTPRDESPFILI < @V_DTINICIAL) BEGIN
                  UPDATE APURACAOROP
                  SET  DTINIAPURACROP  = @V_NEW_DTPRDESPFILI
                  WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);
               END;
         END;
      END;

      IF @V_ID_COMANDO = 'D' BEGIN
         SELECT @V_IDUTPADRROP = IDUTPADRROP
         FROM PARAMGERAL G;

         SELECT @V_IDFECHDIAROP   = ISNULL(MAX(IDFECHDIAROP),'N'),
                @V_IDUTPADRROPFIL = ISNULL(MAX(IDUTPADRROPFIL),'N')
         FROM  PARFILIALROP
         WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);

         IF @V_IDUTPADRROP = 'S' OR @V_IDUTPADRROPFIL = 'S' BEGIN
            SELECT @V_IDFECHDIAROP   = ISNULL(MAX(IDFECHDIAROP),'N'),
                   @V_IDUTPADRROPFIL = ISNULL(MAX(IDUTPADRROPFIL),'N')
            FROM  PARFILIALROP
            WHERE CDFILIAL = 'P';
         END;

         SELECT @V_DTINICIAL = MAX(DTINIAPURACROP),
                   @V_DTFINAL   = MAX(DTFINAPURACROP)
            FROM APURACAOROP
            WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);

            IF (ISNULL(@V_IDFECHDIAROP,'N') <> 'S') BEGIN

               IF (@V_OLD_DTPRDESPFILI < @V_DTFINAL)  AND (@V_OLD_DTPRDESPFILI < @V_DTINICIAL) BEGIN

                  UPDATE APURACAOROP
                  SET DTINIAPURACROP  = @V_OLD_DTPRDESPFILI
                  WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);
               END;

            END
            ELSE BEGIN
               DELETE ROPFILIAL
               WHERE CDFILIAL     = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL)  AND
                     DTFILIALROP  >= @V_NEW_DTPRDESPFILI;

               IF (@V_OLD_DTPRDESPFILI < @V_DTINICIAL) BEGIN
                  UPDATE APURACAOROP
                  SET  DTINIAPURACROP  = @V_OLD_DTPRDESPFILI
                  WHERE CDFILIAL = ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL);
               END;
         END;
      END;


      FETCH NEXT FROM C_CURSOR_DATA INTO @V_ID_COMANDO,
                                      @V_OLD_CDFILIAL,
                                      @V_OLD_DTPRDESPFILI,
                                      @V_NEW_CDFILIAL,
                                      @V_NEW_DTPRDESPFILI,
                                      @V_NEW_VRPRDESPFILI,
                                      @V_NEW_VRREDESPFILI,
                                      @V_OLD_VRPRDESPFILI,
                                      @V_OLD_VRREDESPFILI;

   END;
   CLOSE C_CURSOR_DATA;
   DEALLOCATE C_CURSOR_DATA;
END;

GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_DADOS_DESPDIVERSA','5.11.000';
GO

